## mingw-w64-sundials-6.7.0-4.src.tar.zst

=== examples/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): David J. Gardner and Slaven Peles @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2023, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples level CMakeLists.txt for SUNDIALS
# ---------------------------------------------------------------

# Set variables used in generating CMake and Makefiles for examples
if(EXAMPLES_INSTALL)

  set(SHELL "sh")
  set(prefix "${CMAKE_INSTALL_PREFIX}")
  set(exec_prefix "${CMAKE_INSTALL_PREFIX}")
  set(includedir "${prefix}/include")
  set(libdir "${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
  set(CPP "${_EXAMPLES_C_COMPILER}")
  set(CPPFLAGS "${CMAKE_C_FLAGS_RELEASE}")
  set(CC "${_EXAMPLES_C_COMPILER}")
  set(CFLAGS "${CMAKE_C_FLAGS_RELEASE}")
  set(LDFLAGS "${CMAKE_EXE_LINKER_FLAGS_RELEASE}")
  list2string(EXE_EXTRA_LINK_LIBS LIBS)
  list2string(EXE_EXTRA_LINK_LIBS EXAMPLES_EXTRA_LIBS)

  if(CXX_FOUND)
    set(CXX "${_EXAMPLES_CXX_COMPILER}")
    set(CXX_LNKR "${_EXAMPLES_CXX_COMPILER}")
    set(CXXFLAGS "${CMAKE_CXX_FLAGS_RELEASE} ${CMAKE_CXX${CMAKE_CXX_STANDARD}_STANDARD_COMPILE_OPTION}")
    set(CXX_LDFLAGS "${CMAKE_CXX_FLAGS_RELEASE}")
    list2string(EXE_EXTRA_LINK_LIBS CXX_LIBS)
  endif()

  if(SUPERLUMT_FOUND)
    list2string(SUPERLUMT_LIBRARIES SUPERLUMT_LIBS)
    set(SUPERLUMT_LIBS "${SUPERLUMT_LINKER_FLAGS} ${SUPERLUMT_LIBS}")
  endif()

  if(KLU_FOUND)
    list2string(KLU_LIBRARIES KLU_LIBS)
    set(KLU_LIBS "${KLU_LINKER_FLAGS} ${KLU_LIBS}")
  endif()

  if(LAPACK_FOUND)
    list2string(LAPACK_LIBRARIES LAPACK_LIBS)
  endif()

  if(MPI_C_FOUND)
    if(MPI_C_COMPILER)
      set(MPICC "${MPI_C_COMPILER}")
      set(MPI_INC_DIR ".")
      set(MPI_LIB_DIR ".")
      set(MPI_LIBS "")
      set(MPI_FLAGS "")
    else()
      set(MPICC "${_EXAMPLES_C_COMPILER}")
      set(MPI_INC_DIR "${MPI_INCLUDE_PATH}")
      set(MPI_LIB_DIR ".")
      list2string(MPI_LIBRARIES MPI_LIBS)
    endif()
    set(HYPRE_INC_DIR "${HYPRE_INCLUDE_DIR}")
    set(HYPRE_LIB_DIR "${HYPRE_LIBRARY_DIR}")
    set(HYPRE_LIBS "${HYPRE_LIBRARIES}")
  endif()

  if(MPI_CXX_FOUND)
    if(MPI_CXX_COMPILER)
      set(MPICXX "${MPI_CXX_COMPILER}")
    else()
      set(MPICXX "${_EXAMPLEX_CXX_COMPILER}")
      list2string(MPI_LIBRARIES MPI_LIBS)
    endif()
  endif()

endif()


#----------------------------------------
# Add specific examples
#----------------------------------------

# Add ARKode examples
if(BUILD_ARKODE)
  add_subdirectory(arkode)
endif()

# Add CVODE examples
if(BUILD_CVODE)
  add_subdirectory(cvode)
endif()

# Add CVODES Examples
if(BUILD_CVODES)
  add_subdirectory(cvodes)
endif()

# Add IDA examples
if(BUILD_IDA)
  add_subdirectory(ida)
endif()

# Add IDAS examples
if(BUILD_IDAS)
  add_subdirectory(idas)
endif()

# Add KINSOL examples
if(BUILD_KINSOL)
  add_subdirectory(kinsol)
endif()

# Add CPODES examples
if(BUILD_CPODES)
  add_subdirectory(cpodes)
endif()

# Add the nvector examples
add_subdirectory(nvector)

# Add the sunmatrix examples
add_subdirectory(sunmatrix)

# Add the sunlinearsolver examples
add_subdirectory(sunlinsol)

# Add the sunnonlinearsolver examples
add_subdirectory(sunnonlinsol)

=== examples/cvode/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): David J. Gardner, Slaven Peles, and
#                Shelby Lockhart @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2023, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples/cvode level CMakeLists.txt for SUNDIALS
# ---------------------------------------------------------------

# C examples
if(EXAMPLES_ENABLE_C)
  add_subdirectory(serial)
  if(ENABLE_OPENMP AND OPENMP_FOUND)
    add_subdirectory(C_openmp)
  endif()
  if(ENABLE_OPENMP_DEVICE AND OPENMP_FOUND AND OPENMP_SUPPORTS_DEVICE_OFFLOADING)
    add_subdirectory(C_openmpdev)
  endif()
  if(ENABLE_MPI AND MPI_C_FOUND)
    add_subdirectory(parallel)
    add_subdirectory(C_mpimanyvector)
  endif()
  if(ENABLE_HYPRE AND HYPRE_FOUND)
    add_subdirectory(parhyp)
  endif()
  if(ENABLE_PETSC AND PETSC_FOUND)
    add_subdirectory(petsc)
  endif()
endif()

# CXX examples
if(EXAMPLES_ENABLE_CXX)
  add_subdirectory(CXX_serial)
  if(ENABLE_HIP)
    add_subdirectory(hip)
  endif()
  if(ENABLE_MAGMA AND MAGMA_FOUND)
    add_subdirectory(magma)
  endif()
  if(ENABLE_GINKGO AND Ginkgo_FOUND)
    add_subdirectory(ginkgo)
  endif()
  if(BUILD_SUNLINSOL_KOKKOSDENSE)
    add_subdirectory(kokkos)
  endif()
  if(BUILD_SUNLINSOL_ONEMKLDENSE)
    add_subdirectory(CXX_onemkl)
  endif()
  if(ENABLE_RAJA AND RAJA_FOUND)
    add_subdirectory(raja)
  endif()
  if(BUILD_NVECTOR_SYCL)
    add_subdirectory(CXX_sycl)
  endif()
  # MPI based examples
  if(ENABLE_MPI AND MPI_CXX_FOUND)
    add_subdirectory(CXX_parallel)
    # hypre examples
    if(ENABLE_HYPRE AND HYPRE_FOUND)
      add_subdirectory(CXX_parhyp)
    endif()
    # SuperLU_DIST examples
    if(ENABLE_SUPERLUDIST AND SUPERLUDIST_FOUND)
      add_subdirectory(superludist)
    endif()
  endif()
endif()

# Fortran examples
if(BUILD_FORTRAN_MODULE_INTERFACE AND EXAMPLES_ENABLE_F2003)
  add_subdirectory(F2003_serial)
endif()

# CUDA examples
if(EXAMPLES_ENABLE_CUDA)

  if(ENABLE_CUDA AND CMAKE_CUDA_COMPILER)
    add_subdirectory(cuda)
  endif()

endif()

=== examples/ida/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): David J. Gardner, Slaven Peles, and
#                Cody Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2023, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples/ida level CMakeLists.txt for SUNDIALS
# ---------------------------------------------------------------

# C examples
if(EXAMPLES_ENABLE_C)
  add_subdirectory(serial)
  if(ENABLE_OPENMP AND OPENMP_FOUND)
    add_subdirectory(C_openmp)
  endif()
  if(ENABLE_MPI AND MPI_C_FOUND)
    add_subdirectory(parallel)
  endif()
  if(ENABLE_PETSC AND PETSC_FOUND)
    add_subdirectory(petsc)
  endif()
endif()

# C++ examples
if(EXAMPLES_ENABLE_CXX)
  if(ENABLE_RAJA AND RAJA_FOUND)
    add_subdirectory(raja)
    if(ENABLE_MPI AND MPI_C_FOUND AND (SUNDIALS_RAJA_BACKENDS MATCHES "CUDA"))
      add_subdirectory(mpiraja)
    endif()
  endif()
  if(ENABLE_TRILINOS AND Trilinos_FOUND)
    add_subdirectory(trilinos)
  endif()
endif()

# Fortran examples
if(BUILD_FORTRAN_MODULE_INTERFACE AND EXAMPLES_ENABLE_F2003)
  add_subdirectory(F2003_serial)
endif()

# cuda examples
if(EXAMPLES_ENABLE_CUDA)

  if(ENABLE_CUDA AND CMAKE_CUDA_COMPILER)
    add_subdirectory(cuda)
    if(ENABLE_MPI AND MPI_C_FOUND)
      add_subdirectory(mpicuda)
    endif()
  endif()

endif()

=== examples/idas/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): David J. Gardner and Slaven Peles @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2023, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# examples/idas level CMakeLists.txt for SUNDIALS
# ---------------------------------------------------------------

# C examples
if(EXAMPLES_ENABLE_C)
  add_subdirectory(serial)
  if(ENABLE_OPENMP AND OPENMP_FOUND)
    add_subdirectory(C_openmp)
  endif()
  if(ENABLE_MPI AND MPI_C_FOUND)
    add_subdirectory(parallel)
  endif()
endif()

if(BUILD_FORTRAN_MODULE_INTERFACE AND EXAMPLES_ENABLE_F2003)
  add_subdirectory(F2003_serial)
endif()

=== examples/sunnonlinsol/CMakeLists.txt ===
# ------------------------------------------------------------------------------
# Programmer(s): David J. Gardner @ LLNL
# ------------------------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2023, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ------------------------------------------------------------------------------
# examples/sunnonlinsol level CMakeLists.txt for SUNDIALS
# ------------------------------------------------------------------------------

if(ENABLE_CALIPER AND SUNDIALS_BUILD_WITH_PROFILING)
  include_directories(${caliper_INCLUDE_DIR})
  set(EXE_EXTRA_LINK_LIBS ${EXE_EXTRA_LINK_LIBS} caliper)
endif()

# Always add the Newton and fixed point examples
add_subdirectory(newton)
add_subdirectory(fixedpoint)

if(BUILD_SUNNONLINSOL_PETSCSNES)
    add_subdirectory(petsc)
endif()

=== src/arkode/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Daniel R. Reynolds @ SMU, Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2023, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the ARKODE library
# ---------------------------------------------------------------

install(CODE "MESSAGE(\"\nInstall ARKODE\n\")")

# Add variable arkode_SOURCES with the sources for the ARKODE library
set(arkode_SOURCES
  arkode_adapt.c
  arkode_arkstep_io.c
  arkode_arkstep_nls.c
  arkode_arkstep.c
  arkode_bandpre.c
  arkode_bbdpre.c
  arkode_butcher_dirk.c
  arkode_butcher_erk.c
  arkode_butcher.c
  arkode_erkstep_io.c
  arkode_erkstep.c
  arkode_interp.c
  arkode_io.c
  arkode_ls.c
  arkode_mri_tables.c
  arkode_mristep_io.c
  arkode_mristep_nls.c
  arkode_mristep.c
  arkode_relaxation.c
  arkode_root.c
  arkode_sprkstep_io.c
  arkode_sprkstep.c
  arkode_sprk.c
  arkode_user_controller.c
  arkode.c
)

# Add variable arkode_HEADERS with the exported ARKODE header files
set(arkode_HEADERS
  arkode.h
  arkode_arkstep.h
  arkode_bandpre.h
  arkode_bbdpre.h
  arkode_butcher.h
  arkode_butcher_dirk.h
  arkode_butcher_erk.h
  arkode_erkstep.h
  arkode_ls.h
  arkode_mristep.h
  arkode_sprk.h
  arkode_sprkstep.h
)

# Add prefix with complete path to the ARKODE header files
add_prefix(${SUNDIALS_SOURCE_DIR}/include/arkode/ arkode_HEADERS)

# Create the sundials_arkode library
sundials_add_library(sundials_arkode
  SOURCES
    ${arkode_SOURCES}
  HEADERS
    ${arkode_HEADERS}
  INCLUDE_SUBDIR
    arkode
  OBJECT_LIBRARIES
    sundials_generic_obj
    sundials_sunmemsys_obj
    sundials_nvecserial_obj
    sundials_sunadaptcontrollerimexgus_obj
    sundials_sunadaptcontrollersoderlind_obj
    sundials_sunmatrixband_obj
    sundials_sunmatrixdense_obj
    sundials_sunmatrixsparse_obj
    sundials_sunlinsolband_obj
    sundials_sunlinsoldense_obj
    sundials_sunlinsolspbcgs_obj
    sundials_sunlinsolspfgmr_obj
    sundials_sunlinsolspgmr_obj
    sundials_sunlinsolsptfqmr_obj
    sundials_sunlinsolpcg_obj
    sundials_sunnonlinsolnewton_obj
    sundials_sunnonlinsolfixedpoint_obj
  OUTPUT_NAME
    sundials_arkode
  VERSION
    ${arkodelib_VERSION}
  SOVERSION
    ${arkodelib_SOVERSION}
)

# Finished ARKODE
message(STATUS "Added ARKODE module")

# Add F2003 module if the interface is enabled
if(BUILD_FORTRAN_MODULE_INTERFACE)
  add_subdirectory(fmod)
endif()

# Add ARKODE XBraid interface
if(ENABLE_XBRAID)
  add_subdirectory(xbraid)
endif()

=== src/ida/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Daniel R. Reynolds @ SMU
#                Radu Serban, Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2023, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the IDA library
# ---------------------------------------------------------------

install(CODE "MESSAGE(\"\nInstall IDA\n\")")

# Add variable ida_SOURCES with the sources for the IDA library
set(ida_SOURCES
  ida.c
  ida_bbdpre.c
  ida_direct.c
  ida_ic.c
  ida_io.c
  ida_ls.c
  ida_nls.c
  ida_spils.c
  )

# Add variable ida_HEADERS with the exported IDA header files
set(ida_HEADERS
  ida.h
  ida_bbdpre.h
  ida_direct.h
  ida_ls.h
  ida_spils.h
  )

# Add prefix with complete path to the IDA header files
add_prefix(${SUNDIALS_SOURCE_DIR}/include/ida/ ida_HEADERS)

# Create the library
sundials_add_library(sundials_ida
  SOURCES
    ${ida_SOURCES}
  HEADERS
    ${ida_HEADERS}
  INCLUDE_SUBDIR
    ida
  OBJECT_LIBRARIES
    sundials_generic_obj
    sundials_sunmemsys_obj
    sundials_nvecserial_obj
    sundials_sunmatrixband_obj
    sundials_sunmatrixdense_obj
    sundials_sunmatrixsparse_obj
    sundials_sunlinsolband_obj
    sundials_sunlinsoldense_obj
    sundials_sunlinsolspbcgs_obj
    sundials_sunlinsolspfgmr_obj
    sundials_sunlinsolspgmr_obj
    sundials_sunlinsolsptfqmr_obj
    sundials_sunlinsolpcg_obj
    sundials_sunnonlinsolnewton_obj
    sundials_sunnonlinsolfixedpoint_obj
  OUTPUT_NAME
    sundials_ida
  VERSION
    ${idalib_VERSION}
  SOVERSION
    ${idalib_SOVERSION}
)

# Finished IDA
message(STATUS "Added IDA module")

# Add F2003 module if the interface is enabled
if(BUILD_FORTRAN_MODULE_INTERFACE)
  add_subdirectory(fmod)
endif()

=== src/sundials/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Radu Serban and Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2023, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the generic SUNDIALS modules
# ---------------------------------------------------------------

# From here we only install the generic SUNDIALS headers.
# The implementations themselves are incorporated in the individual SUNDIALS solver libraries.

install(CODE "MESSAGE(\"\nInstall shared components\n\")")

# Add variable sundials_HEADERS with the exported SUNDIALS header files
set(sundials_HEADERS
  sundials_adaptcontroller.h
  sundials_base.hpp
  sundials_band.h
  sundials_context.h
  sundials_context.hpp
  sundials_convertibleto.hpp
  sundials_dense.h
  sundials_direct.h
  sundials_iterative.h
  sundials_linearsolver.h
  sundials_linearsolver.hpp
  sundials_math.h
  sundials_matrix.h
  sundials_matrix.hpp
  sundials_memory.h
  sundials_memory.hpp
  sundials_mpi_types.h
  sundials_nonlinearsolver.h
  sundials_nonlinearsolver.hpp
  sundials_nvector.h
  sundials_nvector.hpp
  sundials_profiler.h
  sundials_profiler.hpp
  sundials_logger.h
  sundials_types.h
  sundials_version.h
  )

if(BUILD_FORTRAN_MODULE_INTERFACE)
  list(APPEND sundials_HEADERS sundials_futils.h)
endif()

if(ENABLE_CUDA)
  list(APPEND sundials_HEADERS sundials_cuda_policies.hpp)
endif()

if(ENABLE_HIP)
  list(APPEND sundials_HEADERS sundials_hip_policies.hpp)
endif()

if(ENABLE_SYCL)
  list(APPEND sundials_HEADERS sundials_sycl_policies.hpp)
endif()

# If Blas/Lapack support was enabled, add the Lapack interface headers
if(BUILD_SUNLINSOL_LAPACKBAND OR BUILD_SUNLINSOL_LAPACKDENSE)
  list(APPEND sundials_HEADERS sundials_lapack.h)
endif()

# If enabled, add the XBraid interface header
if(ENABLE_XBRAID)
  list(APPEND sundials_HEADERS sundials_xbraid.h)
endif()

# Add prefix with complete path to the header files
add_prefix(${SUNDIALS_SOURCE_DIR}/include/sundials/ sundials_HEADERS)

set(sundials_SOURCES
  sundials_adaptcontroller.c
  sundials_band.c
  sundials_context.c
  sundials_dense.c
  sundials_direct.c
  sundials_iterative.c
  sundials_linearsolver.c
  sundials_logger.c
  sundials_math.c
  sundials_matrix.c
  sundials_memory.c
  sundials_nonlinearsolver.c
  sundials_nvector.c
  sundials_nvector_senswrapper.c
  sundials_version.c
  )

if(SUNDIALS_BUILD_WITH_PROFILING)
  message(WARNING "SUNDIALS built with profiling turned on, performance may be affected.")
  list(APPEND sundials_SOURCES sundials_profiler.c)
endif()

if(BUILD_FORTRAN_MODULE_INTERFACE)
  list(APPEND sundials_SOURCES sundials_futils.c)
endif()

# Add prefix with complete path to the source files
add_prefix(${SUNDIALS_SOURCE_DIR}/src/sundials/ sundials_SOURCES)

if(SUNDIALS_LOGGING_ENABLE_MPI)
  if(ENABLE_MPI AND MPI_C_FOUND)
    # Workaround bug in CMake < 3.17.3 when using MPI::MPI_CXX and CUDA
    set(_include_mpi_if_needed PUBLIC ${MPI_C_INCLUDE_DIRS})
    set(_link_mpi_if_needed PUBLIC ${MPI_C_LIBRARIES})
  endif()
endif()

# Create a library out of the generic sundials modules
sundials_add_library(sundials_generic
  SOURCES
    ${sundials_SOURCES}
  HEADERS
    ${sundials_HEADERS}
  INCLUDE_SUBDIR
    sundials
  INCLUDE_DIRECTORIES
    ${_include_mpi_if_needed}
  LINK_LIBRARIES
    ${_link_mpi_if_needed}
  OUTPUT_NAME
    sundials_generic
  VERSION
    ${sundialslib_VERSION}
  SOVERSION
    ${sundialslib_SOVERSION}
)

# SUNDIALS_EXPORT macro
include(GenerateExportHeader)
generate_export_header(
  sundials_generic BASE_NAME SUNDIALS
  EXPORT_FILE_NAME
  "${PROJECT_BINARY_DIR}/include/sundials/sundials_export.h"
)

# Add F2003 module if the interface is enabled
if(BUILD_FORTRAN_MODULE_INTERFACE)
  add_subdirectory(fmod)
endif()

=== src/sunmatrix/CMakeLists.txt ===
# ------------------------------------------------------------------------------
# Programmer(s): Cody J. Balos @ LLNL
# ------------------------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2023, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ------------------------------------------------------------------------------
# matrix level CMakeLists.txt for SUNDIALS
# ------------------------------------------------------------------------------

# required native matrices
add_subdirectory(band)
add_subdirectory(dense)
add_subdirectory(sparse)

# optional TPL matrices
if(BUILD_SUNMATRIX_CUSPARSE)
  add_subdirectory(cusparse)
endif()

if(BUILD_SUNMATRIX_GINKGO)
  install(CODE "MESSAGE(\"\nInstall SUNMATRIX_GINKGO\n\")")
  message(STATUS "Added BUILD_SUNMATRIX_GINKGO module")
  add_library(sundials_sunmatrixginkgo INTERFACE)
  target_include_directories(sundials_sunmatrixginkgo INTERFACE
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
    $<BUILD_INTERFACE:${SUNDIALS_SOURCE_DIR}/src/sundials>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
  install(FILES ${PROJECT_SOURCE_DIR}/include/sunmatrix/sunmatrix_ginkgo.hpp
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/sunmatrix")
  set(_SUNDIALS_INSTALLED_COMPONENTS "sunmatrixginkgo;${_SUNDIALS_INSTALLED_COMPONENTS}" CACHE INTERNAL "" FORCE)
endif()

if(BUILD_SUNMATRIX_KOKKOSDENSE)
  install(CODE "MESSAGE(\"\nInstall SUNMATRIX_KOKKOSDENSE\n\")")
  message(STATUS "Added BUILD_SUNMATRIX_KOKKOSDENSE module")
  add_library(sundials_sunmatrixkokkosdense INTERFACE)
  target_link_libraries(sundials_sunmatrixkokkosdense INTERFACE
    Kokkos::kokkos Kokkos::kokkoskernels)
  target_include_directories(sundials_sunmatrixkokkosdense INTERFACE
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
    $<BUILD_INTERFACE:${SUNDIALS_SOURCE_DIR}/src/sundials>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
  install(FILES ${PROJECT_SOURCE_DIR}/include/sunmatrix/sunmatrix_kokkosdense.hpp
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/sunmatrix")
  set(_SUNDIALS_INSTALLED_COMPONENTS "sunmatrixkokkosdense;${_SUNDIALS_INSTALLED_COMPONENTS}" CACHE INTERNAL "" FORCE)
endif()

if(BUILD_SUNMATRIX_MAGMADENSE)
  add_subdirectory(magmadense)
endif()

if(BUILD_SUNMATRIX_ONEMKLDENSE)
  add_subdirectory(onemkldense)
endif()

if(BUILD_SUNMATRIX_SLUNRLOC)
  add_subdirectory(slunrloc)
endif()

=== test/unit_tests/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): David J. Gardner @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2023, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# unit_tests level CMakeLists.txt for SUNDIALS
# ---------------------------------------------------------------

message("Adding units tests")

if(BUILD_ARKODE)
  add_subdirectory(arkode)
endif()

if(BUILD_CVODE)
  add_subdirectory(cvode)
endif()

if(BUILD_CVODES)
  add_subdirectory(cvodes)
endif()

if(BUILD_IDA)
  add_subdirectory(ida)
endif()

if(BUILD_IDAS)
  add_subdirectory(idas)
endif()

if(BUILD_KINSOL)
  add_subdirectory(kinsol)
endif()

if(CXX_FOUND)
  add_subdirectory(reductions)
  add_subdirectory(sunmemory)
  if(SUNDIALS_BUILD_WITH_PROFILING)
    add_subdirectory(profiling)
  endif()
endif()

=== benchmarks/diffusion_2D/mpi_gpu/CMakeLists.txt ===
# ------------------------------------------------------------------------------
# Programmer(s): David J. Gardner @ LLNL
# ------------------------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2023, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ------------------------------------------------------------------------------

# list of tests
set(tests )

if(BUILD_ARKODE)
  if(BUILD_NVECTOR_CUDA)
    list(APPEND tests "arkode\;BENCHMARK_ODE\;USE_CUDA")
  endif()
  if(BUILD_NVECTOR_HIP)
    list(APPEND tests "arkode\;BENCHMARK_ODE\;USE_HIP")
  endif()
endif()

if(BUILD_CVODE)
  if(BUILD_NVECTOR_CUDA)
    list(APPEND tests "cvode\;BENCHMARK_ODE\;USE_CUDA")
  endif()
  if(BUILD_NVECTOR_HIP)
    list(APPEND tests "cvode\;BENCHMARK_ODE\;USE_HIP")
  endif()
endif()

if(BUILD_IDA)
  if(BUILD_NVECTOR_CUDA)
    list(APPEND tests "ida\;BENCHMARK_DAE\;USE_CUDA")
  endif()
  if(BUILD_NVECTOR_HIP)
    list(APPEND tests "ida\;BENCHMARK_DAE\;USE_HIP")
  endif()
endif()

# create executables
foreach(test_tuple ${tests})

  # parse the test tuple
  list(GET test_tuple 0 package)
  list(GET test_tuple 1 problem_type)
  list(GET test_tuple 2 backend)

  set(sources
    ${benchmark_prefix}/main_${package}.cpp
    ${shared_sources}
    buffers.cpp
    diffusion.cpp
    solution.cpp
    utils.cpp)

  if("${backend}" STREQUAL "USE_CUDA")

    foreach(file ${sources})
      set_source_files_properties(${file} PROPERTIES LANGUAGE CUDA)
    endforeach()

    set(target ${package}_diffusion_2D_mpicuda)

  else()

    set(target ${package}_diffusion_2D_mpihip)

  endif()

  add_executable(${target} ${sources})

  # if("${backend}" STREQUAL "USE_CUDA")
  #  sundials_add_benchmark(${target} ${target} diffusion_2D
  #    ENABLE_GPU
  #    NUM_CORES ${SUNDIALS_BENCHMARK_NUM_GPUS} 
  #  )
  #endif()

  if("${backend}" STREQUAL "USE_HIP")
    sundials_add_benchmark(${target} ${target} diffusion_2D
      ENABLE_GPU
      NUM_CORES ${SUNDIALS_BENCHMARK_NUM_GPUS}
    )

  endif()

  set_target_properties(${target} PROPERTIES FOLDER "Benchmarks")

  target_compile_definitions(${target} PRIVATE ${problem_type})

  if("${backend}" STREQUAL "USE_CUDA")

    target_compile_definitions(${target} PRIVATE USE_CUDA)

    target_include_directories(${target} PRIVATE ${benchmark_prefix})

    target_link_libraries(${target}
      PRIVATE
      sundials_${package}
      sundials_nvecmpiplusx
      sundials_nveccuda)

  else()

    target_compile_definitions(${target} PRIVATE USE_HIP)

    target_include_directories(${target} PRIVATE ${benchmark_prefix})

    target_link_libraries(${target}
      PRIVATE
      sundials_${package}
      sundials_nvecmpiplusx
      sundials_nvechip
      hip::device)

  endif()

  # Workaround bug in CMake < 3.17.3 when using MPI::MPI_CXX
  target_include_directories(${target} PRIVATE ${MPI_CXX_INCLUDE_DIRS})
  target_link_libraries(${target} PRIVATE ${MPI_CXX_LIBRARIES})

  install(TARGETS ${target}
    DESTINATION "${BENCHMARKS_INSTALL_PATH}/diffusion_2D")

endforeach()

=== benchmarks/nvector/cuda/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2023, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------

message(STATUS "Added CUDA NVECTOR benchmark")

sundials_add_nvector_benchmark(nvector_cuda_benchmark
  SOURCES test_nvector_performance_cuda.cu
  SUNDIALS_TARGETS sundials_nveccuda
  INSTALL_SUBDIR nvector/cuda
  )

=== PKGBUILD ===
# Maintainer: Gene Harvey <gharveymn@gmail.com>

_realname=sundials
pkgbase="mingw-w64-${_realname}"
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=6.7.0
pkgrel=4
pkgdesc="SUite of Nonlinear and DIfferential/ALgebraic equation Solvers (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://computing.llnl.gov/projects/sundials"
msys2_repository_url="https://github.com/LLNL/sundials"
msys2_references=(
  'archlinux: sundials'
)
license=('spdx:BSD-3-Clause')
replaces=("${MINGW_PACKAGE_PREFIX}-cvode")
provides=("${MINGW_PACKAGE_PREFIX}-cvode")
conflicts=("${MINGW_PACKAGE_PREFIX}-cvode")
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-openblas"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-suitesparse"
         $([[ ${CARCH} != x86_64 ]] || echo \
           "${MINGW_PACKAGE_PREFIX}-petsc" \
           "${MINGW_PACKAGE_PREFIX}-superlu_dist"))
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             $([[ ${CARCH} != x86_64 ]] || echo "${MINGW_PACKAGE_PREFIX}-msmpi"))
optdepends=("${MINGW_PACKAGE_PREFIX}-python: for running examples")
source=(https://github.com/LLNL/sundials/releases/download/v${pkgver}/${_realname}-${pkgver}.tar.gz
        '0001-hash-size.patch'
        '0002-sundials-missing-export.patch'
        '0003-sundials-use-default-installdirs.patch'
        '0004-suitesparse-import-target.patch'
        '0008-sundials-petsc-pkg-config-module.patch')
sha256sums=('5f113a1564a9d2d98ff95249f4871a4c815a05dbb9b8866a82b13ab158c37adb'
            '9dd5c708bad0a592a7012c1bdfd91904867cd9efe89412d82706764b21c4537c'
            '7f119fbcc8a630a4e3443e3bba252dafb4b1567ced1bf1389052253529e97ddc'
            '310b9beb86426fd2f817391baf72c0f9aefe9dc31e737daed5cc0280b7693311'
            '753b127af0aa1fbbf03ab67104846f968bd476659cb151d65931b5e5beae3f0d'
            'd4a56ef02d87d8d17970733fe8391c12fea9465f093681a1091a24b2ad0a787a')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Np1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd "${_realname}-${pkgver}"

  apply_patch_with_msg \
    0001-hash-size.patch \
    0002-sundials-missing-export.patch \
    0003-sundials-use-default-installdirs.patch \
    0004-suitesparse-import-target.patch \
    0008-sundials-petsc-pkg-config-module.patch
}

_petsc_arch=dmo

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    export FFLAGS="-Qunused-arguments"
  fi

  if [[ ${CARCH} != x86_64 ]]; then
    # There are currently no msmpi libraries for Windows on ARM.
    # See: https://github.com/microsoft/Microsoft-MPI/issues/66
    # Dont' build the features that require msmpi.
    _extra_config+=("-DENABLE_MPI=OFF"
                    "-DENABLE_PETSC=OFF"
                    "-DENABLE_SUPERLUDIST=OFF")
  else
    _extra_config+=("-DBUILD_NVECTOR_MPIMANYVECTOR=ON"
                    "-DBUILD_NVECTOR_MPIPLUSX=ON"
                    "-DBUILD_NVECTOR_PARALLEL=ON"
                    "-DENABLE_MPI=ON"
                    "-DENABLE_PETSC=ON"
                    "-DENABLE_SUPERLUDIST=ON"
                    "-DPETSC_PKG_CONFIG_MODULE=petsc-${_petsc_arch}"
                    "-DSUNDIALS_LOGGING_ENABLE_MPI=OFF"
                    "-DSUPERLUDIST_INCLUDE_DIRS=${MINGW_PREFIX}/include/superlu_dist"
                    "-DSUPERLUDIST_CONFIG_PATH=${MINGW_PREFIX}/include/superlu_dist/superlu_dist_config.h"
                    "-DSUPERLUDIST_INDEX_SIZE=32"
                    "-DSUPERLUDIST_OpenMP=ON"
                    "-DMPI_C_COMPILER=${MINGW_PREFIX}/bin/mpicc.exe"
                    "-DMPI_CXX_COMPILER=${MINGW_PREFIX}/bin/mpicxx.exe")
  fi

  I_MPI_ROOT="" \
  MSYS2_ARG_CONV_EXCL="CMAKE_INSTALL_PREFIX=;EXAMPLES_INSTALL_PATH=" \
  ${MINGW_PREFIX}/bin/cmake \
    -D BUILD_ARKODE=ON \
    -D BUILD_CVODE=ON \
    -D BUILD_CVODES=ON \
    -D BUILD_FORTRAN_MODULE_INTERFACE=OFF \
    -D BUILD_IDA=ON \
    -D BUILD_IDAS=ON \
    -D BUILD_KINSOL=ON \
    -D BUILD_NVECTOR_MANYVECTOR=ON \
    -D BUILD_NVECTOR_OPENMP=ON \
    -D BUILD_NVECTOR_PTHREADS=ON \
    -D BUILD_SHARED_LIBS=ON \
    -D BUILD_STATIC_LIBS=ON \
    -D BUILD_SUNLINSOL_KLU=ON \
    -D BUILD_SUNLINSOL_LAPACKBAND=ON \
    -D BUILD_SUNLINSOL_LAPACKDENSE=ON \
    -D BUILD_TESTING=OFF \
    "${_extra_config[@]}" \
    -D CMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -D CMAKE_RUNTIME_OUTPUT_DIRECTORY="${srcdir}/build-${MSYSTEM}"/build-output/bin \
    -D CMAKE_SYSTEM_IGNORE_PATH=/usr/lib \
    -D CMAKE_DLL_NAME_WITH_SOVERSION=ON \
    -D ENABLE_CUDA=OFF \
    -D ENABLE_HIP=OFF \
    -D ENABLE_HYPRE=OFF \
    -D ENABLE_KLU=ON \
    -D ENABLE_LAPACK=ON \
    -D ENABLE_MAGMA=OFF \
    -D ENABLE_OPENMP=ON \
    -D ENABLE_OPENMP_DEVICE=OFF \
    -D ENABLE_PTHREAD=ON \
    -D ENABLE_RAJA=OFF \
    -D ENABLE_SUPERLUMT=OFF \
    -D ENABLE_SYCL=OFF \
    -D ENABLE_TRILINOS=OFF \
    -D ENABLE_XBRAID=OFF \
    -D EXAMPLES_ENABLE_C=ON \
    -D EXAMPLES_ENABLE_CXX=ON \
    -D EXAMPLES_ENABLE_F2003=OFF \
    -D EXAMPLES_INSTALL=ON \
    -D EXAMPLES_INSTALL_PATH=${MINGW_PREFIX}/share/sundials/examples \
    -D KLU_LIBRARY=${MINGW_PREFIX}/lib/libklu.dll.a \
    -D LAPACK_LIBRARIES=${MINGW_PREFIX}/lib/libopenblas.dll.a \
    -D SUITESPARSECONFIG_LIBRARY=${MINGW_PREFIX}/lib/libsuitesparseconfig.dll.a \
    -D SUNDIALS_BUILD_WITH_PROFILING=OFF \
    -D SUNDIALS_BUILD_WITH_MONITORING=ON \
    -D SUNDIALS_INDEX_SIZE=32 \
    -D SUNDIALS_PRECISION=DOUBLE \
    -DSUNDIALS_F77_FUNC_CASE=LOWER \
    -DSUNDIALS_F77_FUNC_UNDERSCORES=ONE \
    -B build-${MSYSTEM} \
    -S ${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build build-${MSYSTEM}
}

check() {
  # Skip tests requiring MPI.
  ${MINGW_PREFIX}/bin/cmake -Bbuild-${MSYSTEM} -S${_realname}-${pkgver} -DBUILD_TESTING=ON
  ${MINGW_PREFIX}/bin/cmake --build build-${MSYSTEM}
  ${MINGW_PREFIX}/bin/ctest \
    --exclude-regex "mpi|parallel|petsc|superludist|slunrloc" \
    --test-dir build-${MSYSTEM}
}

package() {
  DESTDIR="${pkgdir}" \
  ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Install the LICENSE and NOTICE files to the system licenses directory.
  install -D --mode=644  \
    --target-directory="${pkgdir}${MINGW_PREFIX}"/share/licenses/${_realname} \
    "${srcdir}/${_realname}-${pkgver}"/{LICENSE,NOTICE}

  ## Patch various files to be relocatable.

  # Patch the CMake export modules.
  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in "${pkgdir}${MINGW_PREFIX}"/lib/cmake/sundials/SUNDIALSTargets*.cmake; do
    sed -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i "${_f}"
    sed -e "s|${MINGW_PREFIX}|\$\{_IMPORT_PREFIX\}|g" -i "${_f}"
  done

  # Patch the CMake config module.
  sed -e "s|${PREFIX_WIN}|\$\{PACKAGE_PREFIX_DIR\}|g" \
      -i "${pkgdir}${MINGW_PREFIX}"/lib/cmake/sundials/SUNDIALSConfig.cmake

  sed -e "s|${MINGW_PREFIX}|\$\{PACKAGE_PREFIX_DIR\}|g" \
      -i "${pkgdir}${MINGW_PREFIX}"/lib/cmake/sundials/SUNDIALSConfig.cmake

  # Patch the CMakeLists.txt files in the examples.
  shopt -s globstar
  for _f in "${pkgdir}${MINGW_PREFIX}"/share/sundials/examples/**/CMakeLists.txt; do
    _fdir=$(dirname "${_f}")
    _relative_root=$(realpath --relative-to="${_fdir}" "${pkgdir}${MINGW_PREFIX}")
    sed -e "s|${PREFIX_WIN}|\$\{CMAKE_CURRENT_LIST_DIR\}/${_relative_root}|g"   -i "${_f}"
    sed -e "s|${MINGW_PREFIX}|\$\{CMAKE_CURRENT_LIST_DIR\}/${_relative_root}|g" -i "${_f}"
  done
}
